;
; HUC.ASM  -  HuC Internal Library
;

; ----
; local variables

          .zp
__remain  .ds 2

          .code

; TODO : optimize, please !!! this is long and slow ...
; ----
; eq
; ----
; test egality of two words
; ----
; IN :  First word on the C stack
;       Another word in A:X
; ----
; OUT : word A:X equals 0 is the two args are egals
;       else non nul
; ----
; REMARK : signed compatible
; ----

eq:
   sax
   cmp [__stack]
   sax
   bne .eq_false_add2
   __addmi       1, __stack

   cmp [__stack]
   bne .eq_false_add1

   __addmi      1, __stack
   lda #1
   rts

.eq_false_add2:
   __addmi	1,__stack
.eq_false_add1:
   __addmi      1,__stack
   cla
   clx

   rts

; TODO : optimize, please !!! this is long and slow ...
;        it only handles unsigned stuff now, bou :(
; ----
; lt
; ----
; compare two words
; ----
; IN :  First word on the C stack
;       Another word in A:X
; ----
; OUT : word A:X is non nul if pushed word is strictly lower than
;       the word in A:X else nul
; ----
; REMARK : signed NON compatible
; ----

ult:    ; unsigned version, slow but works
lt:     ; signed version, doesn't work well
   __addmi      1, __stack
   cmp [__stack]
   bcc .lt_false_add1 ; hibyte of the reg var < hibyte of the pushed var
   beq .lt_must_test_lobyte
   __addmi      1, __stack
   lda #1
   rts

.lt_must_test_lobyte
   __submi       1, __stack
   sax
   cmp [__stack]
   bcc .lt_false_add2       ; lobyte of the reg var < lobyte of the pushed var
   beq .lt_false_add2
   __addmi      2, __stack
   lda #1
   rts

.lt_false_add2:
   __addmi	1,__stack
.lt_false_add1:
   __addmi      1,__stack
   cla
   clx
   rts

; TODO : optimize, please !!! this is long and slow ...
;        it only handles unsigned stuff now, bou :(
; ----
; ge
; ----
; compare two words
; ----
; IN :  First word on the C stack
;       Another word in A:X
; ----
; OUT : word A:X is non nul if pushed word is greater or egal to
;       the word in A:X else nul
; ----
; REMARK : signed NON compatible
; ----

uge:    ; unsigned version, slow but works well
ge:     ; signed version, doesn't work well
    jsr lt
    __notw
    sax   ; it seems that the return value must be in A and not A:X
    rts

; TODO : optimize, please !!! this is slow but short :)
; ----
; ne
; ----
; compare two words
; ----
; IN :  First word on the C stack
;       Another word in A:X
; ----
; OUT : word A:X is non nul if pushed word is diferent from
;       the word in A:X else nul
; ----
; REMARK : signed compatible
; ----

ne:
    jsr eq
    __notw
    sax   ; it seems that the return value must be in A and not A:X
    rts


; TODO : optimize, please !!! this is long and slow ...
;        it only handles unsigned stuff now, bou :(
; ----
; gt
; ----
; compare two words
; ----
; IN :  First word on the C stack
;       Another word in A:X
; ----
; OUT : word A:X is non nul if pushed word is strictly greater than
;       the word in A:X else nul
; ----
; REMARK : signed NON compatible
; ----

ugt:    ; unsigned version, slow but works
gt:     ; signed version, doesn't work well
   __addmi      1, __stack
   cmp [__stack]
   beq .gt_must_test_lobyte
   bcs .gt_false_add1 ; hibyte of the reg var >= hibyte of the pushed var
   __addmi      1, __stack
   lda #1
   rts

.gt_must_test_lobyte
   __submi       1, __stack
   sax
   cmp [__stack]
   bcs .gt_false_add2       ; lobyte of the reg var >= lobyte of the pushed var
   __addmi      2, __stack
   lda #1
   rts

.gt_false_add2:
   __addmi	1,__stack
.gt_false_add1:
   __addmi      1,__stack
   cla
   clx
   rts

; TODO : optimize, please !!! this is long and slow ...
;        it only handles unsigned stuff now, bou :(
; ----
; le
; ----
; compare two words
; ----
; IN :  First word on the C stack
;       Another word in A:X
; ----
; OUT : word A:X is non nul if pushed word is lower or egal to
;       the word in A:X else nul
; ----
; REMARK : signed NON compatible
; ----

ule:    ; unsigned version, slow but works well
le:     ; signed version, doesn't work well
    jsr gt
    __notw
    sax   ; it seems that the return value must be in A and not A:X
    rts


; ----
; asl
; ----
; shift the pushed word left by the register word
; ----
; IN :  First word on the C stack
;       Another word in A:X
; ----
; OUT : Register word egals the previous pushed value
;       shifted left by A:X
; ----
; REMARK : only the lower byte of the right operand is taken in account
;          signed compatible
; ----
asl:
   stx __temp
   __ldwp __stack
   ldy __temp
   beq .asl_end
   sta __temp
   sax

.asl_begin
   asl a
   rol __temp
   dey
   bne .asl_begin

   sax
   lda __temp
.asl_end
   __addmi 2, __stack
   rts


; ----
; asr
; ----
; shift the pushed word right by the register word
; ----
; IN :  First word on the C stack
;       Another word in A:X
; ----
; OUT : Register word egals the previous pushed value
;       shifted right by A:X
; ----
; REMARK : only the lower byte of the right operand is taken in account
;          signed compatible
; ----
asr:
   stx __temp
   __ldwp __stack
   ldy __temp
   beq .asr_end
   sta __temp
   sax

.asr_begin
   cpx #$80
   ror __temp
   ror a

   dey
   bne .asr_begin

   sax
   lda __temp
.asr_end
   __addmi 2, __stack
   rts

; TODO : optimize .... make it available for signed stuff
; ----
; smul
; ----
; multiply the two words
; ----
; IN :  First word on the C stack
;       Another word in A:X
; ----
; OUT : Register word egals the previous pushed value
;       multiplied by A:X
; ----
; REMARK : signed NON compatible
; ----

smul:
  __stw _bx
  __ldwp __stack
  __stw _ax
  jsr mulu16
  __addmi 2, __stack
  __ldw _cx
  rts


; TODO : optimize .... make it available for signed stuff
; ----
; sdiv
; ----
; divide the two words
; ----
; IN :  First word on the C stack
;       Another word in A:X
; ----
; OUT : Register word egals the previous pushed value
;       divided by A:X
; ----
; REMARK : signed NON compatible
; ----

sdiv:
        __stw   __ptr
        __ldwp  __stack
        __stw   __temp

        lda	#0
 	sta	__remain+1
 	ldy	#16
.sdiv_begin:	asl	__temp
 	rol	__temp+1
 	rol	a
 	rol	__remain+1
 	pha
 	cmp	__ptr
 	lda	__remain+1
 	sbc	__ptr+1
	bcc	.sdiv_end
	sta	__remain+1
	pla
	sbc	__ptr
	pha
	inc	__temp
.sdiv_end:	pla
	dey
	bne	.sdiv_begin
	sta	__remain

        __addmi 2, __stack
        __ldw __temp

	rts


; TODO : optimize .... make it available for signed stuff
; ----
; smod
; ----
; give the integer remainder of the two words
; ----
; IN :  First word on the C stack
;       Another word in A:X
; ----
; OUT : Register word egals the remainder of the division of the
;       pushed value by A:X
; ----
; REMARK : signed NON compatible
; ----

smod:
        __stw   __ptr
        __ldwp  __stack
        __stw   __temp

        lda	#0
 	sta	__remain+1
 	ldy	#16
.smod_begin:	asl	__temp
 	rol	__temp+1
 	rol	a
 	rol	__remain+1
 	pha
 	cmp	__ptr
 	lda	__remain+1
 	sbc	__ptr+1
	bcc	.smod_end
	sta	__remain+1
	pla
	sbc	__ptr
	pha
	inc	__temp
.smod_end:	pla
	dey
	bne	.smod_begin
	sta	__remain

        __addmi 2, __stack
        __ldw __remain

	rts

