#include "huc.h"
#include "debug.c"

#define         RACKET    0x4000
#define         BALL      0x4200
#define	    DIGITS  0x4280
#define         DELTA     2
#define         INIT_X    150
#define         INIT_Y    150

init_digit()
{
	int i;
	for (i=0; i<10; i++)
	{

	spr_set(1 + i);
	spr_x(32+i*16);
	spr_y(150);
	spr_pattern(DIGITS + i * 0x40);
         	spr_ctrl(SIZE_MAS|FLIP_MAS, SZ_16x16|NO_FLIP);
         	spr_pal(2);
         	spr_pri(1);
	}

}


main()
{

int sx,sy,i;

	sx = INIT_X;
	sy = INIT_Y;

        load_sprites(0x4000,racket,1);
        load_sprites(0x4200,ball,1);
        load_sprites(0x4280,digits,2);

         init_satb();

	spr_set(0);
	spr_x(sx);
	spr_y(sy);
	spr_pattern(0x4000);
        spr_ctrl(SIZE_MAS|FLIP_MAS, SZ_32x32|NO_FLIP);
        spr_pal(0);
        spr_pri(1);

	init_digit();

/*
	spr_set(2);
	spr_x(sx+16);
	spr_y(sy);
	spr_pattern(DIGITS + 0x40);
         	spr_ctrl(SIZE_MAS|FLIP_MAS, SZ_16x16|NO_FLIP);
         	spr_pal(2);
         	spr_pri(1);

	spr_set(3);
	spr_x(sx+32);
	spr_y(sy);
	spr_pattern(DIGITS + 0x80);
         	spr_ctrl(SIZE_MAS|FLIP_MAS, SZ_16x16|NO_FLIP);
         	spr_pal(2);
         	spr_pri(1);
*/

        set_sprpal(0,racket_colors);
        set_sprpal(1,ball_colors);
        set_sprpal(2,digits_colors);

	for(;;)
	{

	vsync(0);
	
        if (joy(0) & JOY_UP)
	  sy -= DELTA;
        if (joy(0) & JOY_DOWN)
	  sy += DELTA;
        if (joy(0) & JOY_RGHT)
	  sx += DELTA;
        if (joy(0) & JOY_LEFT)
	  sx -= DELTA;

	spr_set(0);
	spr_x(sx);
	spr_y(sy);

	if (joy(0) & JOY_A == JOY_A)
	{
	  spr_pattern(0x4000);
	  spr_pal(0);
         	  spr_ctrl(SIZE_MAS|FLIP_MAS, SZ_32x32|NO_FLIP);

	}
	if (joy(0) & JOY_B == JOY_B)
	{
	  spr_pattern(0x4200);
	  spr_pal(1);
         	  spr_ctrl(SIZE_MAS|FLIP_MAS, SZ_16x16|NO_FLIP);

	}

	satb_update();

	}

  }

newbank(0x4000);

incspr(racket, "racket.pcx",0,0,2,2);

incpal(racket_colors, "racket.pcx",0,1);

incspr(ball, "baball.pcx",0,0,1,1);

incpal(ball_colors, "baball.pcx",0,1);

incspr(digits, "image2.pcx",0,0,1,1);
incspr(digits_1, "image2.pcx",16,0,1,1);
incspr(digits_2, "image2.pcx",32,0,1,1);
incspr(digits_3, "image2.pcx",0,16,1,1);
incspr(digits_4, "image2.pcx",16,16,1,1);
incspr(digits_5, "image2.pcx",32,16,1,1);
incspr(digits_6, "image2.pcx",0,32,1,1);
incspr(digits_7, "image2.pcx",16,32,1,1);
incspr(digits_8, "image2.pcx",32,32,1,1);
incspr(digits_9, "image2.pcx",0,48,1,1);
incspr(digits_A, "image2.pcx",16,48,1,1);
incspr(digits_B, "image2.pcx",32,48,1,1);

incpal(digits_colors, "image2.pcx",0,1);

