;
; Hu-C internal include file
;


; variables
; ----

	.zp
__stack	.ds 2
__ptr	.ds 2
__temp	.ds 2


; macros
; ----

__ldbp	.macro
	 lda	[\1]
	 tax
	.endm

__stbps	.macro
       __stw	<__temp
       __ldwp	 __stack
       __stw	<__ptr
       __ldw	<__temp
	 sax         
	 sta	[__ptr]
	 sax
       __addmi	2,__stack
	.endm

__ldw	.macro
	 ldx	\1
	 lda	\1+1
	.endm

__ldwp	.macro
	 lda	[\1]
	 tax
	 ldy	#1
	 lda	[\1],Y
	.endm

__ldwi	.macro
	 ldx	#low(\1)
	 lda	#high(\1)
	.endm

__stw	.macro
	 stx	\1
	 sta	\1+1
	.endm

__stwp	.macro
	 sax
	 sta	[\1]
	 sax
	 ldy	#1
	 sta	[\1],Y
	.endm

__stwps	.macro
       __stw	<__temp
       __ldwp	 __stack
       __stw	<__ptr
       __ldw	<__temp
       __stwp	 __ptr
       __addmi	2,__stack
	.endm

__pushw	.macro
       __submi	2,__stack
         sax
	 sta	[__stack]
	 sax
	 ldy	#1
	 sta	[__stack],Y
	.endm

__popw	.macro
	 lda	[__stack]
	 tax
	 ldy	#1
	 lda	[__stack],Y
       __addmi	2,__stack
	.endm

__calls	.macro
       __popw
       __stw	__ptr
	 ldy	#high(.x\@)
	 phy
	 ldy	#low(.x\@)
	 phy
	 jmp	[__ptr]
.x\@:
	.endm

__swapw	.macro
	 pha
	 ldy	#1
	 lda	[__stack],Y
	 sta	<__temp
	 lda	[__stack]
	 sax
	 sta	[__stack]
	 pla
	 sta	[__stack],Y
	 lda	<__temp
	.endm


; TODO : check if we need pha/pla or not
__tstw	.macro
         ; pha
	 stx	<__temp
	 ora	<__temp
	 ; pla
	.endm

__aslw	.macro
	 sax
	 asl	A
	 sax
	 rol	A
	.endm

__asls	.macro
	 asl	[__stack]
	 ldy	#1
	 rol	[__stack],Y
	.endm

__asrw	.macro
	 cmp	#$80
	 ror	A
	 sax
	 ror	A
	 sax
	.endm

__extw	.macro
	 cly
	 txa
	 bpl	.x\@
	 ldy	#$FF
.x\@:	 tya
	.endm

__comw	.macro
	 sax
	 eor	#$FF
	 sax
	 eor	#$FF
	.endm

__negw	.macro
	 sax
	 eor	#$FF
	 clc
	 adc	#1
	 sax
	 eor	#$FF
	 adc	#0
	.endm

__boolw	.macro
	 stx	<__temp
	 ora	<__temp
	 clx
	 beq	.x\@
	 inx
.x\@	 cla
	.endm

__notw	.macro
	 stx	<__temp
	 ora	<__temp
	 clx
	 bne	.x\@
	 inx
.x\@	 cla
	.endm

__addwi	.macro
	 clc
	 sax
	 adc	#low(\1)
	 sax
	 adc	#high(\1)
	.endm	

__addmi	.macro
	 pha
	 clc
	 lda	<\2
	 adc	#low(\1)
	 sta	<\2
	 lda	<\2+1
	 adc	#high(\1)
	 sta	<\2+1
	 pla
	.endm	

__subwi	.macro
	 sec
	 sax
	 sbc	#low(\1)
	 sax
	 sbc	#high(\1)
	.endm	

__submi	.macro
	 pha
	 sec
	 lda	<\2
	 sbc	#low(\1)
	 sta	<\2
	 lda	<\2+1
	 sbc	#high(\1)
	 sta	<\2+1
	 pla
	.endm	

__addws	.macro
        sax
        clc
        adc     [__stack]
        sax
        ldy #1
        adc     [__stack],Y
        __addmi 2, __stack
	.endm

__subws	.macro
	stx	<__temp
	sta	<__temp+1
	sec
	lda	[__stack]
	sbc	<__temp
	tax
	ldy	#1
	lda	[__stack],Y
	sbc	<__temp+1
	__addmi	2, __stack
	.endm

__orws	.macro
	 sax
	 ora	[__stack]
	 sax
	 ldy	#1
	 ora	[__stack],Y
       __addmi	2,__stack
	.endm

__andws	.macro
	 sax
	 and	[__stack]
	 sax
	 ldy	#1
	 and	[__stack],Y
       __addmi	2,__stack
	.endm

__eorws	.macro
	 sax
	 eor	[__stack]
	 sax
	 ldy	#1
	 eor	[__stack],Y
       __addmi	2,__stack
	.endm

__lbra	.macro
	 jmp	\1
	.endm

__lbeq	.macro
	 bne	.x\@
	 jmp	\1
.x\@
	.endm

__lbne	.macro
	 beq	.x\@
	 jmp	\1
.x\@
	.endm

__call	.macro
         map    \1
         jsr    \1
;.dummy\@:
;       .if #BANK(.dummy\@) != #BANK(\1)
;               .if #PAGE(.dummy\@) != #PAGE(\1)
;                map    \1
;                jsr    \1
;                lda #PAGE(\1)
;                .else
;
               ; .fail jump between bank not yet implemented, coming very soon

                ;__addmi -6, __stack
                ;ldy 0
                ;lda #PAGE(\1)
                ;sta [__stack],y
                ;iny

                ;lda #BANK(\1)
                ;sta [__stack],y
                ;iny

;                __ldwi \1
;                __pushw
;
;                __ldwi #PAGE(.dummy\@) + 256 * #BANK(.dummy\@)
;                __pushw
;
;                __ldwi #PAGE(\1) + 256 * #BANK(\1)
;                __pushw

                ;lda #PAGE(.dummy\@)
                ;sta [__stack],y
                ;iny

                ;lda #BANK(.dummy\@)
                ;sta [__stack],y

                ;lda #LOW(\1)
                ;sta [__stack],y
                ;iny

                ;lda #HIGH(\1)
                ;sta [__stack],y
                ;iny



;                jsr map_trick

;                .endif
;        .else
;       jsr     \1
;        .endif
        .endm

_set_bgpal .macro
	map \2
        set_bgpal \1,\2,\3
        .endm

_set_sprpal .macro
	map \2
        set_sprpal \1,\2,\3
        .endm

_load_background .macro

	setvwaddr  $0		; set the VRAM address to $0000

        lda #BANK(\1)
	sta   <_ah
	lda   <_ah
	tam   #2
	vload $1000,$4000,#$1000
	inc   <_ah		; second bank
	lda   <_ah
	tam   #2
	vload $2000,$4000,#$1000
	inc   <_ah		; third bank
	lda   <_ah
	tam   #2
	vload $3000,$4000,#$1000
	inc   <_ah		; fourth bank
	lda   <_ah
	tam   #2
	vload $4000,$4000,#$1000
	inc   <_ah		; fifth bank
	lda   <_ah
	tam   #2
	vload $5000,$4000,#$1000

        vsync

        map \2
        set_bgpal #0, \2,#16

	; and finaly copy the BAT

	batcpy $40, #64, \3, \4, \5

	.endm
